searchNodes=[{"doc":"This module exposes the ltree functions. For more information see the PostgreSQL documentation.","ref":"EctoLtree.Functions.html","title":"EctoLtree.Functions","type":"module"},{"doc":"position of first occurrence of b in a; -1 if not found.","ref":"EctoLtree.Functions.html#index/2","title":"EctoLtree.Functions.index/2","type":"macro"},{"doc":"position of first occurrence of b in a, searching starting at offset; negative offset means start -offset labels from the end of the path.","ref":"EctoLtree.Functions.html#index/3","title":"EctoLtree.Functions.index/3","type":"macro"},{"doc":"lowest common ancestor.","ref":"EctoLtree.Functions.html#lca/2","title":"EctoLtree.Functions.lca/2","type":"macro"},{"doc":"cast ltree to text.","ref":"EctoLtree.Functions.html#ltree2text/1","title":"EctoLtree.Functions.ltree2text/1","type":"macro"},{"doc":"number of labels in path.","ref":"EctoLtree.Functions.html#nlevel/1","title":"EctoLtree.Functions.nlevel/1","type":"macro"},{"doc":"subpath of ltree from position start to position end-1 (counting from 0).","ref":"EctoLtree.Functions.html#subltree/3","title":"EctoLtree.Functions.subltree/3","type":"macro"},{"doc":"subpath of ltree starting at position offset, extending to end of path. If offset is negative, subpath starts that far from the end of the path.","ref":"EctoLtree.Functions.html#subpath/2","title":"EctoLtree.Functions.subpath/2","type":"macro"},{"doc":"subpath of ltree starting at position offset, length len. If offset is negative, subpath starts that far from the end of the path. If len is negative, leaves that many labels off the end of the path.","ref":"EctoLtree.Functions.html#subpath/3","title":"EctoLtree.Functions.subpath/3","type":"macro"},{"doc":"cast text to ltree.","ref":"EctoLtree.Functions.html#text2ltree/1","title":"EctoLtree.Functions.text2ltree/1","type":"macro"},{"doc":"This module defines the LabelTree struct. Implements the Ecto.Type behaviour.Fieldslabels","ref":"EctoLtree.LabelTree.html","title":"EctoLtree.LabelTree","type":"module"},{"doc":"Provides custom casting rules from external data to internal representation.","ref":"EctoLtree.LabelTree.html#cast/1","title":"EctoLtree.LabelTree.cast/1","type":"function"},{"doc":"","ref":"EctoLtree.LabelTree.html#decode/1","title":"EctoLtree.LabelTree.decode/1","type":"function"},{"doc":"From internal representation to database.","ref":"EctoLtree.LabelTree.html#dump/1","title":"EctoLtree.LabelTree.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"EctoLtree.LabelTree.html#embed_as/1","title":"EctoLtree.LabelTree.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"EctoLtree.LabelTree.html#equal?/2","title":"EctoLtree.LabelTree.equal?/2","type":"function"},{"doc":"From database to internal representation.","ref":"EctoLtree.LabelTree.html#load/1","title":"EctoLtree.LabelTree.load/1","type":"function"},{"doc":"Returns the underlying schema type.","ref":"EctoLtree.LabelTree.html#type/0","title":"EctoLtree.LabelTree.type/0","type":"function"},{"doc":"","ref":"EctoLtree.LabelTree.html#t:t/0","title":"EctoLtree.LabelTree.t/0","type":"type"},{"doc":"This module provides the necessary functions to encode and decode PostgreSQL’s lquery data type to and from Elixir values. Implements the Postgrex.Extension behaviour.","ref":"EctoLtree.Postgrex.Lquery.html","title":"EctoLtree.Postgrex.Lquery","type":"module"},{"doc":"This module provides the necessary functions to encode and decode PostgreSQL’s ltree data type to and from Elixir values.Implements the Postgrex.Extension behaviour.","ref":"EctoLtree.Postgrex.Ltree.html","title":"EctoLtree.Postgrex.Ltree","type":"module"},{"doc":"EctoLtreeA library that provides the necessary modules to support the PostgreSQL’s ltree data type with Ecto.","ref":"readme.html","title":"EctoLtree","type":"extras"},{"doc":"1. Add the package to your list of dependencies in mix.exsIf you are using Elixir &gt;= v1.7 and Ecto ~&gt; 3.2def deps do [ ... {:ecto_ltree, &quot;~&gt; 0.3.0&quot;} ] endIf you are using Ecto ~&gt; 3.0def deps do [ ... {:ecto_ltree, &quot;~&gt; 0.2.0&quot;} ] endIf you are using Elixir v1.6 and Ecto ~&gt; 2.1def deps do [ ... {:ecto_ltree, &quot;~&gt; 0.1.0&quot;} ] end 2. Define a type module with our custom extensionsPostgrex.Types.define( MyApp.PostgresTypes, [EctoLtree.Postgrex.Lquery, EctoLtree.Postgrex.Ltree] ++ Ecto.Adapters.Postgres.extensions() )3. Configure the Repo to use the previously defined type module config :my_app, MyApp.Repo, adapter: Ecto.Adapters.Postgres, username: &quot;postgres&quot;, password: &quot;postgres&quot;, database: &quot;my_app_dev&quot;, hostname: &quot;localhost&quot;, poolsize: 10, pool: Ecto.Adapters.SQL.Sandbox, types: MyApp.PostgresTypes4. Add a migration to enable the ltree extensiondefmodule MyApp.Repo.Migrations.CreateExtensionLtree do use Ecto.Migration def change do execute(&quot;CREATE EXTENSION ltree&quot;, &quot;DROP EXTENSION ltree&quot;) end end5. Add a migration to create your tabledefmodule MyApp.Repo.Migrations.CreateItems do use Ecto.Migration def change do create table(:items) do add :path, :ltree end create index(:items, [:path], using: :gist) end end6. Define an Ecto Schemadefmodule MyApp.Item do use Ecto.Schema import Ecto.Changeset alias EctoLtree.LabelTree, as: Ltree schema &quot;items&quot; do field :path, Ltree end def changeset(item, params \\\\ %{}) do item |&gt; cast(params, [:path]) end end7. Usageiex(1)&gt; alias MyApp.Repo MyApp.Repo iex(2)&gt; alias MyApp.Item MyApp.Item iex(3)&gt; import Ecto.Query Ecto.Query iex(4)&gt; import EctoLtree.Functions EctoLtree.Functions iex(5)&gt; Item.changeset(%Item{}, %{path: “1.2.3”}) |&gt; Repo.insert! %MyApp.Item{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, “items”&gt;, id: 1, path: %EctoLtree.LabelTree{labels: [“1”, “2”, “3”]} } iex(6)&gt; from(item in Item, select: nlevel(item.path)) |&gt; Repo.one 3The documentation can be found at hexdocs.","ref":"readme.html#quickstart","title":"EctoLtree - Quickstart","type":"extras"},{"doc":"Copyright (c) 2018-2019 Jose Miguel Rivero BrunoThe source code is licensed under The MIT License (MIT)","ref":"readme.html#copyright-and-license","title":"EctoLtree - Copyright and License","type":"extras"}]